aboutsummaryrefslogtreecommitdiffstats
diff options
context:
space:
mode:
authorDenis Shienkov <denis.shienkov@gmail.com>2020-07-31 16:40:08 +0300
committerDenis Shienkov <denis.shienkov@gmail.com>2020-08-04 08:22:25 +0000
commite88743cc0a48994395e6fbde8743c20ddfb796b1 (patch)
tree1e33b5bcd3e9cb1683c679eeb53dcc9ea5b8bbec
parent5e018f19e06949407685ba547d08d7bbef068c78 (diff)
baremetal: Add basic docker-compose auto-tests configuration
This commit adds a basic 'docker-compose' <focal-baremetal> configuration which allows to produce the bare-metal tests. Current docker image contains the following toolchains: * gcc-arm-none-eabi * gcc-avr * gcc-msp430 * sdcc Change-Id: I7e020081dcb763d704c309ffd96fa03b3c56e4fb Reviewed-by: Ivan Komissarov <ABBAPOH@gmail.com> Reviewed-by: Richard Weickelt <richard@weickelt.de>
-rw-r--r--.travis.yml13
-rw-r--r--docker-compose.yml9
-rwxr-xr-xdocker/focal/entrypoint.sh96
-rw-r--r--docker/focal/test-baremetal.Dockerfile45
-rwxr-xr-xscripts/test-baremetal.sh52
5 files changed, 215 insertions, 0 deletions
diff --git a/.travis.yml b/.travis.yml
index 25a23279e..3d650d8b8 100644
--- a/.travis.yml
+++ b/.travis.yml
@@ -75,6 +75,19 @@ jobs:
- docker-compose run bionic qbs build modules.cpp.compilerWrapper:ccache modules.qbsbuildconfig.enableBundledQt:true config:release
- docker-compose run bionic-android-514 scripts/test-qt-for-android.sh release/install-root/usr/local/bin
+ - <<: *build-on-bionic
+ name: With Qbs and with baremetal
+ before_install:
+ - docker-compose pull bionic
+ - docker-compose pull focal-baremetal
+ script:
+ - docker-compose run bionic qbs build modules.cpp.compilerWrapper:ccache modules.qbsbuildconfig.enableBundledQt:true config:release
+ - QBS_AUTOTEST_PROFILE=arm-none-eabi-gcc-9_2 docker-compose run focal-baremetal scripts/test-baremetal.sh release/install-root/usr/local/bin
+ - QBS_AUTOTEST_PROFILE=avr-gcc-5_4 docker-compose run focal-baremetal scripts/test-baremetal.sh release/install-root/usr/local/bin
+ - QBS_AUTOTEST_PROFILE=msp430-gcc-4_6 docker-compose run focal-baremetal scripts/test-baremetal.sh release/install-root/usr/local/bin
+ - QBS_AUTOTEST_PROFILE=sdcc-3_8_0-mcs51 docker-compose run focal-baremetal scripts/test-baremetal.sh release/install-root/usr/local/bin
+ - QBS_AUTOTEST_PROFILE=sdcc-3_8_0-stm8 docker-compose run focal-baremetal scripts/test-baremetal.sh release/install-root/usr/local/bin
+
- &build-on-macos
stage: Build Qbs and and run autotests
name: With Qbs on macOS (xcode 11.3)
diff --git a/docker-compose.yml b/docker-compose.yml
index cd0bad7d2..901d28b93 100644
--- a/docker-compose.yml
+++ b/docker-compose.yml
@@ -5,6 +5,7 @@ x-default-service: &linux
environment:
- BUILD_OPTIONS
- QTEST_FUNCTION_TIMEOUT
+ - QBS_AUTOTEST_PROFILE
volumes:
- .:/qbs
- ~/.ccache:/home/devel/.ccache
@@ -44,6 +45,14 @@ services:
args:
QT_VERSION: 5.14.0
+ focal-baremetal:
+ << : *linux
+ hostname: focal-baremetal
+ image: ${DOCKER_USER:-qbsbuild}/qbsdev:focal-baremetal-0
+ build:
+ dockerfile: docker/focal/test-baremetal.Dockerfile
+ context: .
+
windows:
image: ${DOCKER_USER:-qbsbuild}/qbsdev:windowsservercore-5.15.0_1.16.0-0
build:
diff --git a/docker/focal/entrypoint.sh b/docker/focal/entrypoint.sh
new file mode 100755
index 000000000..40bc5acb9
--- /dev/null
+++ b/docker/focal/entrypoint.sh
@@ -0,0 +1,96 @@
+#!/usr/bin/env bash
+set -e
+
+#############################################################################
+##
+## Copyright (C) 2019 Richard Weickelt <richard@weickelt.de>
+## Contact: https://www.qt.io/licensing/
+##
+## This file is part of Qbs.
+##
+## $QT_BEGIN_LICENSE:LGPL$
+## Commercial License Usage
+## Licensees holding valid commercial Qt licenses may use this file in
+## accordance with the commercial license agreement provided with the
+## Software or, alternatively, in accordance with the terms contained in
+## a written agreement between you and The Qt Company. For licensing terms
+## and conditions see https://www.qt.io/terms-conditions. For further
+## information use the contact form at https://www.qt.io/contact-us.
+##
+## GNU Lesser General Public License Usage
+## Alternatively, this file may be used under the terms of the GNU Lesser
+## General Public License version 3 as published by the Free Software
+## Foundation and appearing in the file LICENSE.LGPL3 included in the
+## packaging of this file. Please review the following information to
+## ensure the GNU Lesser General Public License version 3 requirements
+## will be met: https://www.gnu.org/licenses/lgpl-3.0.html.
+##
+## GNU General Public License Usage
+## Alternatively, this file may be used under the terms of the GNU
+## General Public License version 2.0 or (at your option) the GNU General
+## Public license version 3 or any later version approved by the KDE Free
+## Qt Foundation. The licenses are as published by the Free Software
+## Foundation and appearing in the file LICENSE.GPL2 and LICENSE.GPL3
+## included in the packaging of this file. Please review the following
+## information to ensure the GNU General Public License requirements will
+## be met: https://www.gnu.org/licenses/gpl-2.0.html and
+## https://www.gnu.org/licenses/gpl-3.0.html.
+##
+## $QT_END_LICENSE$
+##
+#############################################################################
+
+#
+# Entrypoint script when starting the container. The script checks the current
+# working directory and changes the uid/gid of developer/users to match whatever
+# is found in the working directory. This is useful to match the user and group
+# of mounted volumes into the container
+
+#
+# If not root, re-run script as root to fix ids
+#
+if [ "$(id -u)" != "0" ]; then
+ exec gosu root /sbin/entrypoint.sh "$@"
+fi
+
+#
+# Try to determine the uid of the working directory and adjust the current
+# user's uid/gid accordingly.
+#
+USER_GID=${USER_GID:-$(stat -c "%g" .)}
+USER_UID=${USER_UID:-$(stat -c "%u" .)}
+USER_NAME=${USER_NAME:-devel}
+USER_GROUP=${USER_GROUP:-devel}
+EXEC=""
+export HOME=/home/${USER_NAME}
+
+#
+# This is a problem on Linux hosts when we mount a folder from the
+# user file system and write artifacts into that. Thus, we downgrade
+# the current user and make sure that the uid and gid matches the one
+# of the mounted project folder.
+#
+# This work-around is not needed on Windows hosts as Windows doesn't
+# have such a concept.
+#
+if [ "${USER_UID}" != "0" ]; then
+ if [ "$(id -u ${USER_NAME})" != "${USER_UID}" ]; then
+ usermod -o -u ${USER_UID} ${USER_NAME}
+ # After changing the user's uid, all files in user's home directory
+ # automatically get the new uid.
+ fi
+ current_gid=$(id -g ${USER_NAME})
+ if [ "$(id -g ${USER_NAME})" != "${USER_GID}" ]; then
+ groupmod -o -g ${USER_GID} ${USER_GROUP}
+ # Set the new gid on all files in the home directory that still have the
+ # old gid.
+ find /home/${USER_NAME} -gid "${current_gid}" ! -type l -exec chgrp ${USER_GID} {} \;
+ fi
+fi
+EXEC="exec gosu ${USER_NAME}:${USER_GROUP}"
+
+if [ -z "$1" ]; then
+ ${EXEC} bash -l
+else
+ ${EXEC} bash -l -c "$*"
+fi
diff --git a/docker/focal/test-baremetal.Dockerfile b/docker/focal/test-baremetal.Dockerfile
new file mode 100644
index 000000000..9d581dd0e
--- /dev/null
+++ b/docker/focal/test-baremetal.Dockerfile
@@ -0,0 +1,45 @@
+#
+# Baremetal toolchains for testing Qbs
+#
+FROM ubuntu:focal
+LABEL Description="Ubuntu baremetal test environment for Qbs"
+
+# Allow colored output on command line.
+ENV TERM=xterm-color
+
+#
+# Make it possible to change UID/GID in the entrypoint script. The docker
+# container usually runs as root user on Linux hosts. When the Docker container
+# mounts a folder on the host and creates files there, those files would be
+# owned by root instead of the current user. Thus we create a user here who's
+# UID will be changed in the entrypoint script to match the UID of the current
+# host user.
+#
+ARG USER_UID=1000
+ARG USER_NAME=devel
+RUN apt-get update -qq && \
+ apt-get install -qq -y \
+ ca-certificates \
+ gosu \
+ sudo && \
+ groupadd -g ${USER_UID} ${USER_NAME} && \
+ useradd -s /bin/bash -u ${USER_UID} -g ${USER_NAME} -o -c "" -m ${USER_NAME} && \
+ usermod -a -G sudo ${USER_NAME} && \
+ echo "%devel ALL = (ALL) NOPASSWD: ALL" >> /etc/sudoers
+
+COPY docker/focal/entrypoint.sh /sbin/entrypoint.sh
+ENTRYPOINT ["/sbin/entrypoint.sh"]
+
+# Install baremetal toolchains and Qbs runtime dependencies.
+RUN apt-get update -qq && \
+ apt-get install -qq -y \
+ libglib2.0-0 \
+ libgssapi-krb5-2 \
+ gcc-arm-none-eabi \
+ gcc-avr \
+ avr-libc \
+ gcc-msp430 \
+ sdcc
+
+# Work-around for QTBUG-79020.
+RUN echo "export QT_NO_GLIB=1" >> /etc/profile.d/qt.sh
diff --git a/scripts/test-baremetal.sh b/scripts/test-baremetal.sh
new file mode 100755
index 000000000..5273d4ba9
--- /dev/null
+++ b/scripts/test-baremetal.sh
@@ -0,0 +1,52 @@
+#!/usr/bin/env bash
+set -eu
+
+#############################################################################
+##
+## Copyright (C) 2020 Denis Shienkov <denis.shienkov@gmail.com>
+## Contact: https://www.qt.io/licensing/
+##
+## This file is part of Qbs.
+##
+## $QT_BEGIN_LICENSE:LGPL$
+## Commercial License Usage
+## Licensees holding valid commercial Qt licenses may use this file in
+## accordance with the commercial license agreement provided with the
+## Software or, alternatively, in accordance with the terms contained in
+## a written agreement between you and The Qt Company. For licensing terms
+## and conditions see https://www.qt.io/terms-conditions. For further
+## information use the contact form at https://www.qt.io/contact-us.
+##
+## GNU Lesser General Public License Usage
+## Alternatively, this file may be used under the terms of the GNU Lesser
+## General Public License version 3 as published by the Free Software
+## Foundation and appearing in the file LICENSE.LGPL3 included in the
+## packaging of this file. Please review the following information to
+## ensure the GNU Lesser General Public License version 3 requirements
+## will be met: https://www.gnu.org/licenses/lgpl-3.0.html.
+##
+## GNU General Public License Usage
+## Alternatively, this file may be used under the terms of the GNU
+## General Public License version 2.0 or (at your option) the GNU General
+## Public license version 3 or any later version approved by the KDE Free
+## Qt Foundation. The licenses are as published by the Free Software
+## Foundation and appearing in the file LICENSE.GPL2 and LICENSE.GPL3
+## included in the packaging of this file. Please review the following
+## information to ensure the GNU General Public License requirements will
+## be met: https://www.gnu.org/licenses/gpl-2.0.html and
+## https://www.gnu.org/licenses/gpl-3.0.html.
+##
+## $QT_END_LICENSE$
+##
+#############################################################################
+
+export PATH="$1:$PATH"
+export QBS_AUTOTEST_ALWAYS_LOG_STDERR=true
+
+echo "Auto-detecting the Qbs profiles."
+qbs-setup-toolchains --detect
+qbs-config --list profiles
+
+echo "Testing the Qbs toolchains."
+export QBS_AUTOTEST_PROFILE=${QBS_AUTOTEST_PROFILE:-arm-none-eabi-gcc-9_2}
+tst_blackbox-baremetal